﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;


namespace Boner
{
    public class Boner : MVRScript
    {
               
        // Boner script and UI variables
        private DAZMorph penisLength;
        private DAZMorph penisWidth;
        private FreeControllerV3 pBase;
        private FreeControllerV3 pMid;
        private FreeControllerV3 pTip;
        public JSONStorableFloat BoneTransitionTimeFloat;
        public JSONStorableFloat BoneGrowPercentFloat;
        public JSONStorableFloat BoneCurvedFloat;
        public JSONStorableFloat BoneStiffnessFloat;
        public JSONStorableBool BonerTrueBool;
        public JSONStorableBool EnableHipCycleBool;
        protected JSONStorableString helpstring;

        // Boner transition targets
        protected JSONStorableFloat targetValPBasJSON;
        protected JSONStorableFloat targetValPDrvJSON;
        protected JSONStorableFloat currentValPSprJSON;
        protected JSONStorableFloat currentValPDrvJSON;
        protected JSONStorableFloat currentValPMoLJSON;
        protected JSONStorableFloat currentValPMoWJSON;
        

        //protected internal float variables
        protected float TransitionCompJoints = 0.0f;
        protected float TransitionCompMorphs = 0.0f;
        protected float UserMorphValuePL = 0.0f;
        protected float UserMorphValuePW = 0.0f;
        protected float UserPSpringValue = 0.0f;
        protected float UserPDriveValue = 0.0f;
        protected float BoneGrowMultiplier = 0.0f;
        protected float RandomizeTimer1 = 0.0f;
        protected float CycleIntensityFactor = 1.0f;
        protected float periodStored = 0.0f;
        protected float forceQuicknessStored = 0.0f;
        protected float torqueQuicknessStored = 0.0f;
        protected float forceFactorStored = 0.0f;
        protected int CFValuesStored = 0;
        protected int RandomizerStarted = 0;

        // CycleForce variables
        protected Rigidbody RB;
        protected ForceProducerV2.AxisName _forceAxis = ForceProducerV2.AxisName.Z;
        protected ForceProducerV2.AxisName _torqueAxis = ForceProducerV2.AxisName.NegX;
        protected JSONStorableFloat periodJSON;
        protected JSONStorableFloat periodRatioJSON;
        protected JSONStorableFloat forceDurationJSON;
        protected JSONStorableFloat forceFactorJSON;
        protected JSONStorableFloat forceQuicknessJSON;
        protected JSONStorableFloat torqueFactorJSON;
        protected JSONStorableFloat torqueQuicknessJSON;
        protected JSONStorableBool applyForceOnReturnJSON;
        protected JSONStorableBool EnableForceRandomizer;


        //Tweakable variables

        //Penis Drive Values {minValueSpring, maxValueSpring, minValueDriveAngle, maxValueDriveAngle}
        float[] pBasDriveValues = { 0.14f, 35.0f, -20.0f, 30.0f };

        // PenisMorphValues {StartValue, MaxValue, smoothness}
        float[] pMorphValuesPL = { 2.0f, 3.0f, 4.0f };
        float[] pMorphValuesPW = { 0.0f, 0.4f, 4.0f };

               

        // Initialization
        public override void Init()
        {
            try
            {
                // Get script controlled morphs
                JSONStorable js = containingAtom.GetStorableByID("geometry");
                if (js != null)
                {
                    DAZCharacterSelector dcs = js as DAZCharacterSelector;
                    GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
                    if (morphUI != null)
                    {
                        penisLength = morphUI.GetMorphByDisplayName("Penis Length");
                        penisWidth = morphUI.GetMorphByDisplayName("Penis Width");
                  
                    }
                }

                // Initialize script conmtrolled joint controllers
                pBase = containingAtom.GetStorableByID("penisBaseControl") as FreeControllerV3;
                if (pBase != null)
                {
                    //pBase.jointRotationDriveSpring = 2.0f;
                    //pBase.jointRotationDriveDamper = 1.0f;
                }

                pMid = containingAtom.GetStorableByID("penisMidControl") as FreeControllerV3;
                if (pMid != null)
                {
                    //pMid.jointRotationDriveSpring = 2.0f;
                    //pMid.jointRotationDriveDamper = 1.0f;
                }

                pTip = containingAtom.GetStorableByID("penisTipControl") as FreeControllerV3;
                if (pTip != null)
                {
                    //pTip.jointRotationDriveSpring = 2.0f;
                    //pTip.jointRotationDriveDamper = 1.0f;
                }


                // ## Create User Interface START ##              

                // Create Boner TRUE toggle
                BonerTrueBool = new JSONStorableBool("Boner TRUE", false);
                BonerTrueBool.storeType = JSONStorableParam.StoreType.Full;
                RegisterBool(BonerTrueBool);
                CreateToggle(BonerTrueBool, true);

                // Create Boner Transition Time slider
                BoneTransitionTimeFloat = new JSONStorableFloat("Boner Transition Time", 4.0f, 0, 10, true, true);
                BoneTransitionTimeFloat.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(BoneTransitionTimeFloat);
                CreateSlider(BoneTransitionTimeFloat, true);

                // Create Boner Grow slider
                BoneGrowPercentFloat = new JSONStorableFloat("Boner Grow  Percentage", 80, 0, 250, true, true);
                BoneGrowPercentFloat.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(BoneGrowPercentFloat);
                CreateSlider(BoneGrowPercentFloat, true);

                // Create Boner Curve slider
                BoneCurvedFloat = new JSONStorableFloat("Boner UpCurve Value", 0.15f, 0.0f, 1.0f, true, true);
                BoneCurvedFloat.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(BoneCurvedFloat);
                CreateSlider(BoneCurvedFloat, true);

                // Create Boner Stiffness slider
                BoneStiffnessFloat = new JSONStorableFloat("Boner Stiffness Value", 35, 0, 200, true, true);
                BoneStiffnessFloat.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(BoneStiffnessFloat);
                CreateSlider(BoneStiffnessFloat, true);

                // Create Apply Force On Return toggle
                applyForceOnReturnJSON = new JSONStorableBool("CF applyForceOnReturn", false);
                applyForceOnReturnJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterBool(applyForceOnReturnJSON);
                CreateToggle(applyForceOnReturnJSON, true);
                
                // Create CycleForce toggle
                EnableHipCycleBool = new JSONStorableBool("Enable Hip CycleForce", false);
                EnableHipCycleBool.storeType = JSONStorableParam.StoreType.Full;
                RegisterBool(EnableHipCycleBool);
                CreateToggle(EnableHipCycleBool, false);

                // Create CF intensity Randomizer toggle
                EnableForceRandomizer = new JSONStorableBool("CF Intensity Randomizer", false);
                EnableForceRandomizer.storeType = JSONStorableParam.StoreType.Full;
                RegisterBool(EnableForceRandomizer);
                CreateToggle(EnableForceRandomizer, false);

                // Create CycleForce sliders
                periodJSON = new JSONStorableFloat("CycleForce period", 0.6f, 0f, 10f, false);
                periodJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(periodJSON);
                CreateSlider(periodJSON, false);

                periodRatioJSON = new JSONStorableFloat("CF periodRatio", 0.5f, 0f, 1f, true);
                periodRatioJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(periodRatioJSON);
                CreateSlider(periodRatioJSON, false);

                forceDurationJSON = new JSONStorableFloat("CF forceDuration", 1f, 0f, 1f, true);
                forceDurationJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(forceDurationJSON);
                CreateSlider(forceDurationJSON, false);

                forceFactorJSON = new JSONStorableFloat("CF forceFactor (thrust)", 40f, 0f, 500f, false, true);
                forceFactorJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(forceFactorJSON);
                CreateSlider(forceFactorJSON, true);

                forceQuicknessJSON = new JSONStorableFloat("CF forceQuickness", 10f, 0f, 50f, false, true);
                forceQuicknessJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(forceQuicknessJSON);
                CreateSlider(forceQuicknessJSON, true);

                torqueFactorJSON = new JSONStorableFloat("CF torqueFactor (tilt)", 30f, 0f, 200f, false, true);
                torqueFactorJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(torqueFactorJSON);
                CreateSlider(torqueFactorJSON, true);

                torqueQuicknessJSON = new JSONStorableFloat("CF torqueQuickness", 10f, 0f, 50f, false, true);
                torqueQuicknessJSON.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(torqueQuicknessJSON);
                CreateSlider(torqueQuicknessJSON, true);

                // ## Create User Interface END ##



                // Initilalize script variables which values shall be stored within the VAM scene
                currentValPSprJSON = new JSONStorableFloat("currentValPSpr", 0f, 0f, 1f, false, false);
                currentValPDrvJSON = new JSONStorableFloat("currentValPDrv", 0f, 0f, 1f, false, false);
                currentValPMoLJSON = new JSONStorableFloat("currentValPMoL", 0f, 0f, 1f, false, false);
                currentValPMoWJSON = new JSONStorableFloat("currentValPMoW", 0f, 0f, 1f, false, false);
                targetValPBasJSON = new JSONStorableFloat("targetValPBas", 0f, 0f, 1f, false, false);
                targetValPDrvJSON = new JSONStorableFloat("targetValPDrv", 0f, 0f, 1f, false, false);


                // Read user set values of controlled morphs and springs 
                UserMorphValuePL = penisLength.morphValue;
                //SuperController.LogMessage("PenisLength =  " + UserMorphValuePL);
                UserMorphValuePW = penisWidth.morphValue;
                //SuperController.LogMessage("PenisWidht =  " + UserMorphValuePW);

                if (UserMorphValuePL < 0.5f)
                {
                    UserMorphValuePL = 0.5f;
                }
                UserMorphValuePW = 0.01f;

                UserPSpringValue = pMid.jointRotationDriveSpring;
                //SuperController.LogMessage("Penis Spring =  " + UserPSpringValue);
                UserPDriveValue = pMid.jointRotationDriveXTarget;
                //SuperController.LogMessage("Penis drive =  " + UserPDriveValue);

                currentValPMoLJSON.val = UserMorphValuePL;
                currentValPMoWJSON.val = UserMorphValuePW;
                currentValPSprJSON.val = UserPSpringValue;
                currentValPDrvJSON.val = UserPDriveValue;

                //penisLength.jsonFloat.val = x; (read/set current value)
                //penisLength.jsonFloat.max = x; (read/set max value)
                //Increase morph slider range
                penisLength.jsonFloat.max = 8f;
                penisWidth.jsonFloat.max = 2f;


                // Define "hip" as CycleForce reciever
                RB = containingAtom.rigidbodies.First(rb => rb.name == "hip");

            }
                catch (Exception e)
                {
                SuperController.LogError("Exception caught: " + e);
                }
        }

        protected float timer;
        protected float forceTimer;
        protected float flip;
        protected Vector3 targetForce;
        protected Vector3 targetTorque;
        protected Vector3 currentForce;
        protected Vector3 currentTorque;

        protected void Start()
        {
            timer = 0f;
            forceTimer = 0f;
            flip = 1f;
        }

        // Updates every frame
        public void Update()
        {

            // Call BoneMotions subroutine
            BoneMotions();
            
            // Call CycleForce subroutine
            if (EnableHipCycleBool.val)
            {
                if (EnableForceRandomizer.val)
                {
                    // Read current slider values for restore
                    if (CFValuesStored == 0)
                    {
                        periodStored = periodJSON.val;
                        forceQuicknessStored = forceQuicknessJSON.val;
                        torqueQuicknessStored = torqueQuicknessJSON.val;
                        forceFactorStored = forceFactorJSON.val;
                        CFValuesStored = 1;
                        RandomizerStarted = 1;
                        //SuperController.LogMessage("CF Slider values:" + periodStored + ", " + forceQuicknessStored + ", " + torqueQuicknessStored + ", " + forceFactorStored);
                    }   


                    RandomizeTimer1 -= Time.deltaTime;
                    if (RandomizeTimer1 < 0.0f)
                    {
                        // delay to next randomize start.
                        RandomizeTimer1 = 6 + UnityEngine.Random.Range(0.0f, 8.0f);
                        // Set target factor
                        CycleIntensityFactor = UnityEngine.Random.Range(0.5f, 1.5f);
                        //SuperController.LogMessage("CycleIntensityFactor = " + CycleIntensityFactor);
                    }

                    // Apply randomized factors
                    periodJSON.val = Mathf.Lerp(periodJSON.val, (periodStored * (2 - CycleIntensityFactor)), Time.deltaTime * 0.5f);
                    forceQuicknessJSON.val = Mathf.Lerp(forceQuicknessJSON.val, (forceQuicknessStored * CycleIntensityFactor), Time.deltaTime * 0.5f);
                    torqueQuicknessJSON.val = Mathf.Lerp(torqueQuicknessJSON.val, (torqueQuicknessStored * CycleIntensityFactor), Time.deltaTime * 0.5f);
                    forceFactorJSON.val = Mathf.Lerp(forceFactorJSON.val, (forceFactorStored * (CycleIntensityFactor * 1.5f)), Time.deltaTime * 0.5f);
                }
                else
                {
                    // restore slider values if randomizer switched off after randomize
                    if (RandomizerStarted == 1)
                    {
                        periodJSON.val = periodStored;
                        forceQuicknessJSON.val = forceQuicknessStored;
                        torqueQuicknessJSON.val = torqueQuicknessStored;
                        forceFactorJSON.val = forceFactorStored;
                        RandomizerStarted = 0;
                        CFValuesStored = 0;
                    }
                }

                HipCycleForce();
            }

        }


        protected virtual Vector3 AxisToVector(ForceProducerV2.AxisName axis)
        {
			Vector3 result;
            if (RB != null)
            {
                switch (axis)
                {
                    case ForceProducerV2.AxisName.X:
                        result = RB.transform.right;
                        break;
                    case ForceProducerV2.AxisName.NegX:
                        result = -RB.transform.right;
                        break;
                    case ForceProducerV2.AxisName.Y:
                        result = RB.transform.up;
                        break;
                    case ForceProducerV2.AxisName.NegY:
                        result = -RB.transform.up;
                        break;
                    case ForceProducerV2.AxisName.Z:
                        result = RB.transform.forward;
                        break;
                    case ForceProducerV2.AxisName.NegZ:
                        result = -RB.transform.forward;
                        break;
                    default:
                        result = Vector3.zero;
                        break;
                }
            }
            else
            {
                result = Vector3.zero;
            }
            return (result);
        } 

        // CycleForce forces definition
        protected void SetTargets(float percent)
        {
            targetForce = AxisToVector(_forceAxis) * percent * forceFactorJSON.val;
            targetTorque = AxisToVector(_torqueAxis) * percent * torqueFactorJSON.val;
        }

        // Subroutine CycleForce Timings 
        public void HipCycleForce()
        {
            timer -= Time.deltaTime;
            forceTimer -= Time.deltaTime;
            if (timer < 0.0f)
            {
                if ((flip > 0f && periodRatioJSON.val != 1f) || periodRatioJSON.val == 0f)
                {
                    if (applyForceOnReturnJSON.val)
                    {
                        flip = -1f;
                    }
                    else
                    {
                        flip = 0f;
                    }
                    timer = periodJSON.val * (1f - periodRatioJSON.val);
                    forceTimer = forceDurationJSON.val * periodJSON.val;
                }
                else
                {
                    flip = 1f;
                    timer = periodJSON.val * periodRatioJSON.val;
                    forceTimer = forceDurationJSON.val * periodJSON.val;
                }
                SetTargets(flip);
            }
            else if (forceTimer < 0.0f)
            {
                SetTargets(0f);
            }

        }


        // FixedUpdate is called with each physics simulation frame by Unity
        // CycleForces applied here
        void FixedUpdate()
        {
            try
            {
                if (EnableHipCycleBool.val)
                {
                    float timeFactor = Time.fixedDeltaTime;
                    currentForce = Vector3.Lerp(currentForce, targetForce, timeFactor * forceQuicknessJSON.val);
                    currentTorque = Vector3.Lerp(currentTorque, targetTorque, timeFactor * torqueQuicknessJSON.val);

                    if (RB && (!SuperController.singleton || !SuperController.singleton.freezeAnimation))
                    {
                        RB.AddForce(currentForce, ForceMode.Force);
                        RB.AddTorque(currentTorque, ForceMode.Force);
                    }
                }
            }
            catch (Exception e) 
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }



      
        // Subroutine drives bone motions and morphs
        public void BoneMotions()
        {

            // Set target values based on Boner true selection 
            if (!BonerTrueBool.val)
            {
                targetValPBasJSON.val = (pBasDriveValues[0]);
                targetValPDrvJSON.val = (pBasDriveValues[2]);
                BoneGrowMultiplier = 1;
                // SuperController.LogMessage("Boner Status " + BonerTrueBool.val);
            }
            if (BonerTrueBool.val)
            {
                targetValPBasJSON.val = BoneStiffnessFloat.val;
                targetValPDrvJSON.val = (pBasDriveValues[3]);
                BoneGrowMultiplier = (1 + BoneGrowPercentFloat.val / 100);
                // SuperController.LogMessage("Boner Status " + BonerTrueBool.val);
            }


            // Modify transition timings depending on grow or shrink transition
            // Grow
            if (currentValPSprJSON.val < 2.5f &&  targetValPBasJSON.val > currentValPSprJSON.val)
            {
                TransitionCompJoints = 40.0f;
                TransitionCompMorphs = 7.0f;
            }
            if (currentValPSprJSON.val > 2.5f && targetValPBasJSON.val > currentValPSprJSON.val)
            {
                // Mathf.Lerp (min value, max value, time)
                TransitionCompJoints = Mathf.Lerp(TransitionCompJoints, 1, Time.deltaTime * 0.2f);
                TransitionCompMorphs = Mathf.Lerp(TransitionCompMorphs, 1, Time.deltaTime * 0.15f);
            }
            // Shrink
            if (currentValPSprJSON.val > 15.0f && targetValPBasJSON.val < currentValPSprJSON.val)
            {
                TransitionCompJoints = 4.0f;
                TransitionCompMorphs = 20.0f;
            }
            if (currentValPSprJSON.val < 15.0f && targetValPBasJSON.val < currentValPSprJSON.val)
            {
                // Mathf.Lerp (min value, max value, time)
                TransitionCompJoints = Mathf.Lerp(TransitionCompJoints, 1, Time.deltaTime * 0.1f);
                TransitionCompMorphs = Mathf.Lerp(TransitionCompMorphs, 1, Time.deltaTime * 0.25f);
            }

            //SuperController.LogMessage("Speed " + TransitionCompJoints);
            
            // Drive Penis Controllers
            currentValPSprJSON.val = Mathf.Lerp(currentValPSprJSON.val, targetValPBasJSON.val, Time.deltaTime / (BoneTransitionTimeFloat.val * TransitionCompJoints));
            currentValPDrvJSON.val = Mathf.Lerp(currentValPDrvJSON.val, targetValPDrvJSON.val, Time.deltaTime / (BoneTransitionTimeFloat.val * TransitionCompJoints));
            pBase.jointRotationDriveXTarget = ((currentValPDrvJSON.val + 3) * BoneCurvedFloat.val);
            pBase.jointRotationDriveSpring = ((currentValPSprJSON.val + 0.5f) * 1.3f);
            pMid.jointRotationDriveXTarget = (currentValPDrvJSON.val * BoneCurvedFloat.val);
            pMid.jointRotationDriveSpring = (currentValPSprJSON.val * 1.0f);
            pTip.jointRotationDriveXTarget = (currentValPDrvJSON.val * BoneCurvedFloat.val * 0.9f);
            pTip.jointRotationDriveSpring = ((currentValPSprJSON.val + 0.5f) * 0.8f);


            // Drive Penis Morphs
            currentValPMoLJSON.val = Mathf.Lerp(currentValPMoLJSON.val, (UserMorphValuePL * BoneGrowMultiplier), Time.deltaTime / (BoneTransitionTimeFloat.val * TransitionCompMorphs));
            currentValPMoWJSON.val = Mathf.Lerp(currentValPMoWJSON.val, ((UserMorphValuePW * BoneGrowMultiplier * 100) - 1), Time.deltaTime / (BoneTransitionTimeFloat.val * TransitionCompMorphs));
            penisLength.morphValue = currentValPMoLJSON.val;
            penisWidth.morphValue = currentValPMoWJSON.val;

        }

    }
}
